/* calc.y */
%{
#include <stdio.h>
int yylex(void);
void yyerror(const char *s);
%}

%token RET
%token <num> NUMBER
%token <op> ADDOP MULOP LPAREN RPAREN
%type <num> top line expr term factor

%start top
%union {
	char  op;
	double num;
}

%%
top : top line {}
	| {}
	;

line : expr RET { printf(" = %f\n", $1); }
	;

expr : term { $$ = $1; };
	| expr ADDOP term
		{
			switch ($2) {
				case '+': $$ = $1 + $3; break;
				case '-': $$ = $1 - $3; break;
			}
		}
	;

term : factor { $$ = $1; }
	| term MULOP factor
		{
			switch ($2) {
				case '*': $$ = $1 * $3; break;
				case '/': $$ = $1 / $3; break; 		// 想想看，这里会出什么问题？
			}
		}
	;

factor : LPAREN expr RPAREN { $$ = $2; }
	| NUMBER { $$ = $1; }
	;
%%

void yyerror(const char *s)
{
	fprintf(stderr, "%s\n", s);
}